package com.ejie.ab79.dao.listados;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import javax.annotation.Resource;
import javax.sql.DataSource;

import org.springframework.context.i18n.LocaleContextHolder;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab79.comun.Constantes;
import com.ejie.ab79.model.listados.Listados;

/**
 * 
 *  
 *
 */

@Repository
@Transactional
public class ListadosDaoImpl implements ListadosDao {

	public static final String[] ORDER_BY_WHITE_LIST = new String[] { "VALOR" };

	private JdbcTemplate jdbcTemplate;

	private RowMapper<Listados> rwMap = new RowMapper<Listados>() {
		@Override
		public Listados mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			Listados listado = new Listados();
			listado.setIdListado(resultSet.getInt("IDLISTADO"));
			if (LocaleContextHolder.getLocale().getLanguage().equalsIgnoreCase(Constantes.CASTELLANO)) {
				listado.setNombre(resultSet.getString("DESCRIPCIONCASTELLANO"));
			} else {
				listado.setNombre(resultSet.getString("DESCRIPCIONEUSKERA"));
			}

			return listado;
		}
	};

	/**
	 * Method use to set the datasource.
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	/**
	 * Finds rows in the Listados table
	 *
	 * @param listados
	 *            Listados
	 * 
	 * @return List<Listados>
	 */
	@Override
	@Transactional(readOnly = true)
	public List<Listados> cargarComboListados(Listados listados) {
		StringBuilder query = new StringBuilder();
		List<Object> params = new ArrayList<Object>();

		query.append(
				"SELECT t6108.ID_LISTADO IDLISTADO,  t6105.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO, t6105.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA");
		query.append(" FROM LISTADOS t6108, REL_LIS_PRO t6105, REL_LIS_PRO_APL t6165");
		query.append(" WHERE t6108.ID_LISTADO = t6105.ID_LISTADO AND t6105.ID_REL_LIS_PRO = t6165.ID_REL_LIS_PRO");
		query.append(
				" AND t6105.ID_PROCEDIMIENTO = ? AND t6165.ID_APLICACION = (SELECT t6146.ID_APLICACION FROM APLICACIONES t6146 WHERE UPPER(t6146.CODIGO_APLICACION) = ?)");
		query.append(
				" UNION SELECT t6108.ID_LISTADO IDLISTADO, t6105.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO, t6105.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA FROM LISTADOS t6108, REL_LIS_PRO t6105, PROCEDIMIENTOS t6101 WHERE t6108.ID_LISTADO   = t6105.ID_LISTADO AND t6101.ID_PROCEDIMIENTO = t6105.ID_PROCEDIMIENTO AND t6101.ID_APLICACION  = (SELECT t6146.ID_APLICACION FROM APLICACIONES t6146 WHERE UPPER(t6146.CODIGO_APLICACION) = ? ) AND t6101.ID_PROCEDIMIENTO = ? ");

		params.add(listados.getProcedimientos().getIdProcedimiento());
		params.add(Constantes.CODIGO_APLICACION.toUpperCase());
		params.add(Constantes.CODIGO_APLICACION.toUpperCase());
		params.add(listados.getProcedimientos().getIdProcedimiento());

		return this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	/**
	 * StringBuilder initilization value
	 */
	public static final int STRING_BUILDER_INIT = 4096;
}
